#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <string.h>
#include <termios.h>
#include <fcntl.h>

#include "serialio.h"

int main()
{
	int radio, dsp100;
	char c;
        int flags;
	int rcnt;
	char rbuf[64];
	int dcnt;
	char dbuf[64];

	serial_open("/dev/cuaU0", &radio);
	serial_open("/dev/cuaU1", &dsp100);

        flags = fcntl (radio, F_GETFL, 0);
        fcntl (radio, F_SETFL, flags | O_NONBLOCK);
        flags = fcntl (dsp100, F_GETFL, 0);
        fcntl (dsp100, F_SETFL, flags | O_NONBLOCK);

	rcnt = 0;
	dcnt = 0;

	while (1) {
		usleep (2000);
		if (read (radio, &c, 1) != -1) {
			rbuf[rcnt] = c;
			rcnt++;
			usleep (2000);
			serial_write (dsp100, &c, 1);
			if (c == ';') {
				rbuf[rcnt] = '\0';
				rcnt = 0;
				printf ("TS850 SAID: [%s]\n", rbuf);
				bzero (rbuf, sizeof(dbuf));
			}
		}
		usleep (2000);
		if (read (dsp100, &c, 1) != -1) {
			dbuf[dcnt] = c;
			dcnt++;
			usleep (2000);
			serial_write (radio, &c, 1);
			if (c == ';') {
				dbuf[dcnt] = '\0';
				dcnt = 0;
				printf ("DSP100 SAID: [%s]\n", dbuf);
				bzero (dbuf, sizeof(dbuf));
			}
		}
	}

	exit(0);
}
